
SuperStrict

'====================================================================================================================================================

Const MAP_WIDTH:Int = 16
Const MAP_HEIGHT:Int = 16

'====================================================================================================================================================

Type TTile
	Field x:Int
	Field y:Int
	
	Field previous:TTile			'Das vorherige Tile im Pfad
	Field movCost:Int				'Bewegungskosten vom Start zu diesem Tile
	Field estDist:Int				'Geschtzte Entfernung zum Ziel
	Field total:Int					' = movCost + estDist
	
	Field tileIndex:Int				'Index im Tileset
End Type


Type TPath
	Field nodes:TList
	
	Method New()
		Self.nodes = CreateList()
	End Method
	
	Method smoothen( p:TPerson )
		
		'Neue Liste erstellen und zeug hinzufgen
		Local newList:TList = CreateList()
		newList.addFirst( Self.nodes.first() )		
		
		'For Local node:TPathNode = EachIn Self.nodes
		Local node:TPathNode = TPathNode( Self.nodes.first() )
		'Local exitflag:Int
		Repeat
			
			''Rckwrts alle Nodes durchgehen
			'Local rev:TList = Self.nodes.reversed()
			Local node2:TPathNode = TPathNode( Self.nodes.last() )
			'For node2 = EachIn Self.nodes
			Repeat
				
				'Falls man keine gerade Linie ziehen kann, ohne unbegehbare Tiles zu schneiden, ...
				If( LineMapIntersection( node.x, node.y, node2.x, node2.y, 8 ) = False ) Then
					'Den Node davor der neuen Liste hinzufgen
					'Local prevLink:TLink = Self.nodes.findLink( node2 ).prevLink()
					'Local n:TPathNode = TPathNode( prevLink.value() )
					newList.addFirst( node2 )
					Exit
				End If
				
				Local nextLink2:TLink = Self.nodes.findLink( node2 ).prevLink()
				If( nextLink2 = Null ) Then Exit
				
				node2 = TPathNode( nextLink2.value() )
				If( node2 = node ) Then Exit
				
			Forever
			
			'If( exitflag = True ) Then Exit
			
			Local temp:TPathNode = node
			node = node2
			If( node = temp ) Then Exit
			
			Local nextLink:TLink = Self.nodes.findLink( node ).nextLink()
			If( nextLink = Null ) Then
				Exit
			End If
			
		Forever
		
		'Neue Liste annehmen
		Self.nodes = newList
		
		Local i:Int = Min( 1, CountList( Self.nodes )-1 )
		p.nextNode = TPathNode( Self.nodes.valueAtIndex( i ) )
		
	End Method
End Type

Type TPathNode
	Field X:Int
	Field Y:Int
End Type

Type TPerson
	Field X:Double
	Field Y:Double
	Field Speed:Double
	
	Field path:TPath
	Field nextNode:TPathNode
	
	Method New()
		Self.path = New TPath
		Self.Speed = 3
	End Method
	
	Method update()
		If( Self.nextNode <> Null And CountList( Self.path.nodes ) > 0 ) Then
			Local dx:Double = Self.nextNode.x - Self.x
			Local dy:Double = Self.nextNode.y - Self.y
			Local l:Float = Max( 0.00001, Sqr( dx^2 + dy^2 ) )
			
			dx = dx / l * Self.speed
			dy = dy / l * Self.speed
			
			Self.x :+ dx
			Self.y :+ dy
			
			If(	Self.x > Self.nextNode.x-Self.speed/2 And Self.x < Self.nextNode.x+Self.speed/2 And ..
				Self.y > Self.nextNode.y-Self.speed/2 And Self.y < Self.nextNode.y+Self.speed/2 ) Then
				Local nl:TLink = Self.path.nodes.findLink( Self.nextNode ).nextLink()
				If nl <> Null Then
					Self.nextNode = TPathNode( nl.value() )
				Else
					Self.nextNode = Null
				End If
			End If
			
			Local c1:Int = PointMapIntersection( Self.x-4, Self.y )
			Local c2:Int = PointMapIntersection( Self.x+4, Self.y )
			Local c3:Int = PointMapIntersection( Self.x, Self.y+4 )
			Local c4:Int = PointMapIntersection( Self.x, Self.y-4 )
			If( c1 Or c2 Or c3 Or c4 ) Then
				Self.nextNode = Null
				Self.x :- dx
				Self.y :- dy
			End If
		End If
	End Method
	
	Method go( dx:Int, dy:Int )
		FindPath( Self, dx, dy )
	End Method
End Type

Type TPlayer Extends TPerson
	Field destX:Int
	Field destY:Int
	
	Method init()
		Self.destX = -1
		Self.destY = -1
	End Method
	
	Method update()
		If MouseHit( MOUSE_RIGHT ) And MouseX() < 16*32 And MouseY() < 16*32 Then
			Self.destX = MouseX()
			Self.destY = MouseY()
			FindPath( Self, Self.destX, Self.destY )
		End If
		
		If MouseHit( MOUSE_LEFT ) And MouseX() < 16*32 And MouseY() < 16*32 Then
			map[ MouseX()/32, MouseY()/32 ].tileIndex = 1 - map[ MouseX()/32, MouseY()/32 ].tileIndex
			If( Self.destX <> -1 Or Self.destY <> -1 ) Then FindPath( Self, Self.destX, Self.destY )
		End If
		
		Super.update()
	End Method
End Type

Type TEnemy Extends TPerson
	'Field destX:Int
	'Field destY:Int
	
	Field lastUpdate:Int
	
	Field ang:Int
	Field dis:Int
	
	Method init()
		'Self.destX = -1
		'Self.destY = -1
		
		Self.lastUpdate = -1
	End Method
	
	Method update()
		'If( Self.destX = -1 Or Self.destY = -1 Or  ) Then
		If( ( lastUpdate = -1 Or lastUpdate + ( 500 + Rand( 200 ) ) < MilliSecs() ) And( Not( Abs( Self.x - player.x ) < 64 And Abs( Self.y - player.y ) < 64 ) ) ) Then
			Local destX:Int = Max( 0, Min( player.x + Cos(ang)*dis, MAP_WIDTH*32-32 ) )
			Local destY:Int = Max( 0, Min( player.y + Sin(ang)*dis, MAP_HEIGHT*32-32 ) )
			FindPath( Self, destX, destY )
			Self.lastUpdate = MilliSecs()
			
			If( CountList( Self.path.nodes ) = 0 ) Then 
				Self.ang = Rand( 0, 359 )
				Self.dis = Rand( 50, 100 )
			End If
		End If
		
		Super.update()
	End Method
End Type

'====================================================================================================================================================

Global frametimer:TTimer

'====================================================================================================================================================

Global tileset:TImage

Global tileAcc:Int[2]				'Gibt an ob ein Tile begehbar ist

Global map:TTile[16,16]

Global player:TPlayer
Global enemies:TList
'Global enemy:TEnemy

Global path:TPath

'====================================================================================================================================================

Init()

'====================================================================================================================================================

While Not KeyHit( KEY_ESCAPE )
	Update()
	Render()
	
	WaitTimer( frametimer )
	Flip( 0 )
	Cls()
Wend

'====================================================================================================================================================

Function FindPath:Int( p:TPerson, destX:Int, destY:Int )
	
	Local startX:Int = p.x
	Local startY:Int = p.y
	
	Local tsx:Int = startX/32
	Local tsy:Int = startY/32
	Local tdx:Int = destX/32
	Local tdy:Int = destY/32
	
	'Altes Zeug entfernen
	For Local x:Int = 0 To MAP_WIDTH - 1
		For Local y:Int = 0 To MAP_HEIGHT - 1
			map[x,y].previous = Null
			map[x,y].movCost = 0
			map[x,y].estDist = 0
			map[x,y].total = 0
		Next
	Next
	
	'Alten Pfad lschen
	ClearList( p.path.nodes )
	
	'Offene und geschlossene Listen erstellen
	Local OpenList:TList = CreateList()
	Local ClosedList:TList = CreateList()
	
	'Start-Tile zur offenen Liste hinzufgen
	OpenList.AddLast( map[tsx, tsy] )
	
	
	Repeat
		'Finde das Tile mit der "niedrigsten Bewertung" (-> aktuelles Tile)
		Local tile:TTile
		Local least:Int = -1
		For Local t:TTile = EachIn OpenList
			If( least = -1 Or t.total < least ) Then
				least = t.total
				tile = t
			End If
		Next
		
		'Ziel gefunden
		If tile = map[tdx, tdy] Then Exit
		
		'Entferne das aktuelle Tile aus der offenen Liste und verschiebe es in die geschlossene Liste
		OpenList.remove( tile )
		ClosedList.addLast( tile )
		
		'Umliegende Tiles bearbeiten
		For Local ax:Int = -1 To 1
			For Local ay:Int = -1 To 1
				'Das hier in eine Funktion auslagern bitte danke
				If( tile.x+ax > -1 And tile.x+ax < MAP_WIDTH And tile.y+ay > -1 And tile.y+ay < MAP_HEIGHT ) Then
					
					Local tile2:TTile = map[tile.x+ax, tile.y+ay]
					If( IsAccessible( tile, tile2 ) And ListContains( ClosedList, tile2 ) = False ) Then
					
						'Tile ist noch nicht in der offenen Liste
						If ListContains( OpenList, tile2 ) = False Then
							OpenList.AddLast( tile2 )
							tile2.previous = tile
							tile2.movCost = tile.movCost + MovingCost( tile, tile2 )
							tile2.estDist = EstimatedDistance( tile2, map[tdx, tdy] )
							tile2.total = tile2.movCost + tile2.estDist
							
						'Tile ist bereits in der offenen Liste
						Else
							Local newCost:Int = tile.movCost + MovingCost( tile, tile2 )
							If( newCost < tile2.movCost ) Then
								tile2.movCost = newCost
								tile2.total = tile2.estDist + tile2.movCost
								tile2.previous = tile
							End If
						End If
					End If
				End If
			Next
		Next
		
		'Offene Liste leer, Ziel nicht gefunden -> Abbruch
		If CountList( OpenList ) = 0 Then Return 0
	Forever
	
	'Pfad updaten
	Local tile:TTile = map[tdx, tdy]
	Repeat
		Local node:TPathNode = New TPathNode
		node.x = tile.x*32+16
		node.y = tile.y*32+16
		p.path.nodes.addLast( node )
		
		If( tile = map[tsx, tsy] ) Then
			Local n:TPathNode
			n = New TPathNode
			n.x = p.x
			n.y = p.y
			If( node.x <> n.x Or node.y <> n.y ) Then p.path.nodes.addLast( n )
			n = New TPathNode
			n.x = destX
			n.y = destY
			p.path.nodes.addFirst( n )
			
			p.path.smoothen( p )
			Return 1
		End If
		tile = tile.previous
	Forever
	
End Function

'====================================================================================================================================================

'Gibt zurck, ob man von einem Tile zu einem anderen (benachbarten) Tile gelangen kann
Function IsAccessible:Int( s:TTile, e:TTile )
	Local dx:Int = e.x-s.x
	Local dy:Int = e.y-s.y
	Return ( tileAcc[e.tileIndex] = 1 And tileAcc[map[s.x+dx,s.y].tileIndex] = 1 And tileAcc[map[s.x,s.y+dy].tileIndex] = 1 )
End Function

'Berechnet die Bewegungskosten von einem Tile zu einem benachbarten
Function MovingCost:Int( s:TTile, e:TTile )
	If( Abs(s.x-e.x) + Abs(s.y-e.y) = 1 ) Then		'horizontal, vertikal
		Return 10
	Else											'diagonal
		Return 14
	End If
End Function

'Berechnet die geschtzte Distanz von einem Tile zum Ziel
Function EstimatedDistance:Int( s:TTile, e:TTile )
	Local xDist:Int = Abs(s.x-e.x)
	Local yDist:Int = Abs(s.y-e.y)
	Return 14*Min(xDist, yDist) + 10*Abs(xDist-yDist)
End Function

'====================================================================================================================================================

'Gibt zurck ob eine Linie sich mit unbegehbaren Tiles auf der Map schneidet
Function LineMapIntersection:Int( x1:Double, y1:Double, x2:Double, y2:Double, r:Double)
	Local angle:Double = ATan2( y1-y2, x1-x2 )
	If( angle < 0 ) Then angle = 360 + angle
	Local na1:Double = angle+90
	Local na2:Double = angle-90
	
	Local l:Double = Sqr( (x2-x1)^2 + (y2-y1)^2 )
	For Local i:Int = 0 To l Step 8
		Local x:Double = x1 - Cos(angle)*i
		Local y:Double = y1 - Sin(angle)*i
		If( PointMapIntersection( x, y ) = 1 ) Then Return 1
		Local x_:Double
		Local y_:Double
		x_ = x - Cos(na1)*r
		y_ = y - Sin(na1)*r
		If( PointMapIntersection( x_, y_ ) = 1 ) Then Return 1
		x_ = x - Cos(na2)*r
		y_ = y - Sin(na2)*r
		If( PointMapIntersection( x_, y_ ) = 1 ) Then Return 1
	Next
End Function

'Gibt zurck, ob ein Punkt auf einem unbegehbaren Tile auf der Map liegt
Function PointMapIntersection:Int( x:Int, y:Int )
	If( x/32 < MAP_WIDTH And y/32 < MAP_HEIGHT And x/32 >= 0 And y/32 >= 0 ) Then
		Return ( Not( tileAcc[ map[x/32,y/32].tileIndex ] ) )
	Else
		Return 0
	End If
End Function

'====================================================================================================================================================

Function LoadMap( filename:String )
	
	Local filestream:TStream = ReadFile( filename )
	
	For Local y:Int = 0 To MAP_HEIGHT - 1
		For Local x:Int = 0 To MAP_WIDTH - 1
			map[x,y] = New TTile
			map[x,y].x = x
			map[x,y].y = y
			map[x,y].tileIndex = ReadInt( filestream ) 
		Next
	Next
	
	CloseFile( filestream )
	
End Function

'====================================================================================================================================================

Function Init()
	'Grafikfenster initialisieren
	Graphics( 800, 600 )
	
	'Frametimer erstellen
	frametimer = CreateTimer( 60 )
	
	'Tileset laden
	tileset = LoadAnimImage( "gfx\tiles.png", 32, 32, 0, 2 )
	
	'Begehbarkeit von Tiles lesen
	For Local i:Int = 0 To 1
		ReadData( tileAcc[i] )
	Next
	
	'Map laden
	LoadMap( "data/0" )
	Rem
	For Local y:Int = 0 To MAP_HEIGHT - 1
		For Local x:Int = 0 To MAP_WIDTH - 1
			map[x,y] = New TTile
			map[x,y].x = x
			map[x,y].y = y
			ReadData map[x,y].tileIndex
		Next
	Next
	End Rem
	
	' ======== TEST =========
	'Player erstellen
	player = New TPlayer
	player.init()
	player.x = 80
	player.y = 80
	
	enemies = CreateList()
	Local e:TEnemy
	
	SeedRnd( MilliSecs() )
	
	For Local i:Int = 0 To 24
		e = New TEnemy
		e.init()
		Repeat
			e.x = Rand( 8, 504 )
			e.y = Rand( 8, 504 )
		Until( PointMapIntersection( e.x, e.y ) = False )
		e.ang = Rand(1, 359)
		e.dis = Rand(50,100)
		enemies.addLast( e )
	Next
	' ======== TEST =========
	
	'Pfad erstellen
	path = New TPath
End Function

Function Update()
	
	player.update()
	
	For Local e:TEnemy = EachIn enemies
		e.update()
	Next
	
End Function

Function Render()
	For Local x:Int = 0 To MAP_WIDTH - 1
		For Local y:Int = 0 To MAP_HEIGHT - 1
			DrawImage( tileset, x*32, y*32, map[x,y].tileIndex )
		Next
	Next
	
	' ======= TEST =======
	SetColor 192,128,96
	DrawOval player.x-8, player.y-8, 16, 16
	
	SetColor 255,0,128
	For Local e:TEnemy = EachIn enemies
		DrawOval e.x-8, e.y-8, 16, 16
	Next
	
	' ======= TEST =======
	
	Rem
	SetColor 0,0,255
	For Local node:TPathNode = EachIn path.nodes
		Local nextLink:TLink = path.nodes.findLink( node ).nextLink()
		If( nextLink = Null ) Then Exit
		Local node2:TPathNode = TPathNode( nextLink.value() )
		DrawLine( node.x, node.y, node2.x, node2.y )
	Next
	End Rem
	
	SetColor 255,255,255
End Function

'====================================================================================================================================================

'Begehbarkeit von Tiles
'Index: 00, 01
DefData  1,  0